#region Copyright Syncfusion Inc. 2001 - 2019
// Copyright Syncfusion Inc. 2001 - 2019. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion

namespace Serialization
{
    using Serialization.Model;
    using Syncfusion.PivotAnalysis.Base;
    using Syncfusion.Windows.Controls.Grid;
    using Syncfusion.Windows.Controls.PivotGrid;
    using System;
    using System.Windows;

    public partial class MainWindow : Window
    {
        private string xmlString;
        public MainWindow()
        {
            InitializeComponent();
            this.pivotGrid1.Loaded += PivotGrid1_Loaded;
        }

        private void PivotGrid1_Loaded(object sender, RoutedEventArgs e)
        {
            if (this.pivotGrid1.ShowCalculationsAsColumns)
            {
                //To hide the row grand totals alone.
                int row = this.pivotGrid1.PivotEngine.RowCount - 2;
                PivotCellInfo cellInfo = this.pivotGrid1.PivotEngine.PivotValues[row, 0];
                if (cellInfo != null && cellInfo.CellType == (PivotCellType.RowHeaderCell | PivotCellType.GrandTotalCell))
                {
                    this.pivotGrid1.InternalGrid.Model.RowHeights.SetHidden(row, row, true);
                    this.pivotGrid1.InternalGrid.InvalidateCells();
                }

                //To hide the column grand totals alone.
                int col = this.pivotGrid1.PivotEngine.ColumnCount - this.pivotGrid1.PivotCalculations.Count - 1;
                PivotCellInfo cellInfo1 = this.pivotGrid1.PivotEngine.PivotValues[0, col];
                if (cellInfo1 != null && cellInfo1.CellType == (PivotCellType.HeaderCell | PivotCellType.ColumnHeaderCell | PivotCellType.GrandTotalCell))
                {
                    for (int i = 0; i < this.pivotGrid1.PivotCalculations.Count; i++)
                    {
                        this.pivotGrid1.InternalGrid.Model.ColumnWidths.SetHidden(col + i, col + i, true);
                        this.pivotGrid1.InternalGrid.InvalidateCells();
                    }
                }
            }
            else
            {
                //To hide the row grand totals alone.
                int row = this.pivotGrid1.PivotEngine.RowCount - this.pivotGrid1.PivotCalculations.Count - 1;
                PivotCellInfo cellInfo = this.pivotGrid1.PivotEngine.PivotValues[row, 0];
                if (cellInfo != null && cellInfo.CellType == (PivotCellType.RowHeaderCell | PivotCellType.GrandTotalCell))
                {
                    for (int i = 0; i < this.pivotGrid1.PivotCalculations.Count; i++)
                    {
                        this.pivotGrid1.InternalGrid.Model.RowHeights.SetHidden(row + i, row + i, true);
                        this.pivotGrid1.InternalGrid.InvalidateCells();
                    }
                }

                //To hide the column grand totals alone.
                int col = this.pivotGrid1.PivotEngine.ColumnCount - 2;
                PivotCellInfo cellInfo1 = this.pivotGrid1.PivotEngine.PivotValues[0, col];
                if (cellInfo1 != null && cellInfo1.CellType == (PivotCellType.HeaderCell | PivotCellType.ColumnHeaderCell | PivotCellType.GrandTotalCell))
                {
                    this.pivotGrid1.InternalGrid.Model.ColumnWidths.SetHidden(col, col, true);
                    this.pivotGrid1.InternalGrid.InvalidateCells();                    
                }
            }
        }

        private void BtnSerialize_Click(object sender, RoutedEventArgs e)
        {
            xmlString = this.pivotGrid1.SerializedXmlString();
        }

        private void BtnDeserialize_Click(object sender, RoutedEventArgs e)
        {
            this.pivotGrid1.DeserializeXmlString(xmlString);
        }
    }
}